__author__ = 'vahid'


import tw2.core as twc
import tw2.forms as twf
import tw2.jquery as twj


class BootstrapMixin(twc.Widget):
    """ Abstract base class for tw2.bootstrap.forms widgets. """

    #template = "genshi:tw2.bootstrap.forms.templates.bootstrap"

    resources = []

    selector = twc.Variable("Escaped id.  jQuery selector.")

#    @classmethod
#    def post_define(cls):
#        pass
#        # put custom initialisation code here
#
    def prepare(self):
        super(BootstrapMixin, self).prepare()
        if 'id' in self.attrs:
            self.selector = "#" + self.attrs['id'].replace(':', '\\:')


class Form(BootstrapForm):
    role = twc.Param(default='form', attribute=True)

class BootstrapForm(BootstrapMixin, twf.Form):
    """ Base class for bootstrap forms. """
    children = twc.Required
    submit = SubmitButton(id='submit', value='Save')
    #attrs = {'role': 'form'}